//*****************************************************************************
// File Name            : ps2_ap_de0_sw1.c
//-----------------------------------------------------------------------------
// Function             : OpenCores IP PS2 
//
//-----------------------------------------------------------------------------
// Designer             : yokomizo
//-----------------------------------------------------------------------------
// History
// -.-- 2014/01/21
//*****************************************************************************


#ifdef __hal__
  #include "sys/alt_stdio.h"
  #include "system.h"
  // BASEADDR
  #define PS2_BASEADDR    0x50000000
  #define PS2_REG0 (*(volatile unsigned char *)(PS2_BASEADDR + 0x0))
  #define PS2_REG1 (*(volatile unsigned char *)(PS2_BASEADDR + 0x1))
  // PRINT macro
  #define M_PRINT(str)  alt_putstr(str);
  #define M_PRINTF(str, ...) printf(str, __VA_ARGS__);
#elif __microblaze__
  #include <stdio.h>
  #include "platform.h"
  #include "xbasic_types.h"
  #include "XIOModule.h"
  // BASEADDR
  #define PS2_BASEADDR    0xD0000000
  #define PS2_REG0 (*(volatile unsigned char *)(PS2_BASEADDR + 0x0))
  #define PS2_REG1 (*(volatile unsigned char *)(PS2_BASEADDR + 0x1))
  // PRINT macro
  #define M_PRINT(str)  print(str);
  #define M_PRINTF(str, ...) xil_printf(str, __VA_ARGS__);
#endif
/*
#include <stdio.h>
#include "platform.h"

#define PS2_BASEADDR    0xD0000000
#define PS2_REG0 (*(volatile unsigned char *)(PS2_BASEADDR + 0x0))
#define PS2_REG1 (*(volatile unsigned char *)(PS2_BASEADDR + 0x1))

void print(char *str);
*/
int main()
{
    unsigned char rcv_data,data_0,data_1,data_2;
    int lp,device_flg=1; //foCX 0:}EX 1:L[{[h
    #ifdef __microblaze__
      init_platform();
    #endif
    M_PRINT("reset send 0xff\n");
    PS2_REG0 = 0xff;//Zbg(0xff)M
    do{
      while(0x0== (PS2_REG1 & 0x2));//M҂
      rcv_data =PS2_REG0;//Mf[^ۑ
      PS2_REG1 = PS2_REG1 & 0xFE;//MtONA
      M_PRINTF("rcv %2x\n",rcv_data);
    }while(rcv_data!=0xaa);//Mf[^acki0xaa)҂
    device_flg =1;//ftHg̓L[{[h
    for(lp=0;lp<10000;lp++){//10000M𔻒
      if (0x2== (PS2_REG1 & 0x2)){ //M
       	rcv_data = PS2_REG0;
        PS2_REG1 = PS2_REG1 & 0xFE;//ibf clear
    	M_PRINTF("rcv %2x\n",rcv_data);
    	if(rcv_data==0x0) //Mf[^}EXhci0x0jȂ
          device_flg=0;   //tO}EXɐݒ
        break;
      }
    }
    if (device_flg==1){ //L[{[h̏ꍇ
      M_PRINT("keyborad \n");
      while(1){
        while(0x0== (PS2_REG1 & 0x2));//M҂
        PS2_REG1 = PS2_REG1 & 0xFE;
        data_0 = PS2_REG0;
        M_PRINTF("%2x\n",data_0);
      }
    }
    else{ //}EX̏ꍇ
        M_PRINT("mouse / start stream send 0xf4\n");
        PS2_REG0 = 0xf4;//f[^|[gi0xf4j𑗐M
        M_PRINT("rcv ");
        while(0x0== (PS2_REG1 & 0x2));//ACKM҂
        PS2_REG1 = PS2_REG1 & 0xFE;//MtONA
        M_PRINTF("%2x\n",PS2_REG0);
        while(1){
          while(0x0== (PS2_REG1 & 0x2));//M҂
          PS2_REG1 = PS2_REG1 & 0xFE;
          data_0 = PS2_REG0;
          while(0x0== (PS2_REG1 & 0x2));//M҂
          PS2_REG1 = PS2_REG1 & 0xFE;
          data_1 = PS2_REG0;
          while(0x0== (PS2_REG1 & 0x2));//M҂
          PS2_REG1 = PS2_REG1 & 0xFE;
          data_2 = PS2_REG0;
          M_PRINTF("S=%2x X=%2x Y=%2x\n",data_0,data_1,data_2);
        }
    }

    return 0;
}
